Magellan Linux

Diff of /branches/mage-next/src/smage2.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

trunk/mage/usr/lib/mage/smage2.sh revision 57 by niro, Tue Feb 15 00:37:07 2005 UTC branches/mage-next/src/smage2.in revision 2631 by niro, Mon Mar 10 12:15:30 2014 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3    
4  # compiles/installs .smage2 source install scripts  # compiles/installs .smage2 source install scripts
5  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
6    
7  # SMAGE2  # TODO: record dynlib, gz | xz database
 # version: 0.3.6-r12  
8    
9  #01.10.2004  
10  # added ccache support  # set default variables
11  # added distcc support  : ${MAGERC="@@SYSCONFDIR@@/mage.rc"}
12    : ${MLIBDIR="@@MAGELIBDIR@@"}
13    
14    # export default C locale
15    export LC_ALL=C
16    
17    # first of all include common functions
18    source ${MLIBDIR}/common.functions.sh || exit 1
19    source @@SYSCONFDIR@@/mage.rc.global || die "@@SYSCONFDIR@@/mage.rc.global missing."
20    source ${MAGERC} || die "${MAGERC} missing."
21    source ${MLIBDIR}/mage4.functions.sh || die "${MLIBDIR}/mage4.functions.sh missing."
22    source ${MLIBDIR}/smage2.functions.sh || die "${MLIBDIR}/smage2.functions.sh missing."
23    
24    # export default path
25    export PATH="${PATH}:${MLIBDIR}"
26    
27    print_usage()
28    {
29     echo "Usage: $(basename $0) [option] pkgname ..."
30     echo "Options:"
31     echo "--smage"
32     echo "--src-tarball"
33     echo "--calc"
34     echo "--update"
35     echo "--download"
36     echo "--regen"
37     echo "--create-src-tarball"
38     echo "--resume"
39     echo
40     echo "Environment variables::"
41     echo " NOCOLORS=true $(basename $0) [src]install PACKAGE"
42     echo " Disables all colors in the messages."
43     echo
44    }
45    
46    # very basic getops
47    for i in $*
48    do
49     case $1 in
50     --smage|*.${SMAGESUFFIX}) shift; SMAGENAME="$1" ;;
51     --src-tarball) shift; SRCPKGTARBALL="$1" ;;
52     --calc) shift; SMAGENAME="$1" ;;
53     --update) ;;
54     --download) shift; SMAGENAME="$1" ;;
55     --regen) shift; SMAGENAME="$1" ;;
56     --create-src-tarball) shift; SMAGENAME="$1" ;;
57     --resume) ;;
58     esac
59     shift
60    done
61    
62  ## setup ##  ## setup ##
 SMAGEVERSION=0.3.6-r11  
 PKGSUFFIX="mpk"  
63  SMAGENAME="$1"  SMAGENAME="$1"
 SMAGESUFFIX="smage2"  
 #SOURCEDIR="/bootstrap/sources"  
 #SMAGESCRIPTSDIR="/bootstrap/smage2-install-scripts"  
 #SMAGE2RSYNC="rsync://192.168.0.2/smage2-scripts"  
 MLIBDIR=/usr/lib/mage  
   
 source /etc/mage.rc  
   
 showversion() {  
  echo -en "Magellan Source Install v${SMAGEVERSION} "  
  echo -e  "-- Niels Rogalla (niro@magellan-linux.de)"  
 }  
64    
65  die() {  # expand PKGDIR, BUILDDIR and BINDIR with MROOT
66   xtitleclean  if [[ -n ${MROOT} ]]
67   echo "SMAGE failed: $@"  then
68     export PKGDIR=${MROOT}/${PKGDIR}
69     export BUILDDIR=${MROOT}/${BUILDDIR}
70     export BINDIR=${MROOT}/${BINDIR}
71    fi
72    
73    # print out our version
74    showversion
75    echo
76    
77    if [[ -z ${SMAGENAME} ]]
78    then
79     echo "No .smage2 file given. Exiting."
80     echo
81   exit 1   exit 1
82  }  fi
83    
84  xtitle() {  # load supported mage features
85   if [ ${TERM} == "xterm" ]  load_mage_features
  then  
  echo -ne "\033]0;[sMage: $@]\007"  
  fi  
  return 0  
 }  
86    
87  xtitleclean() {  # updating smage2-scripts
88   if [ ${TERM} == "xterm" ]  if [[ $1 = update ]]
89    then
90     if [ ! -d ${SOURCEDIR} ]
91   then   then
92   echo -ne "\033]0;\007"   install -d ${SOURCEDIR}
93   fi   fi
94   return 0   syncsmage2
95  }   exit 0
96    fi
97    
98  syncsmage2() {  # creates md5sums for smages to given dir
99   xtitle "Updating smage2-script tree ..."  if [[ $1 = calcmd5 ]]
100   local i  then
101   for i in ${SMAGE2RSYNC}   if [ $# -ge 2 ]
102   do   then
103   rsync \   SMAGENAME="$2"
104   --recursive \   MD5DIR="$3"
105   --links \   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
  --perms \  
  --times \  
  --devices \  
  --timeout=600 \  
  --verbose \  
  --compress \  
  --progress \  
  --stats \  
  --delete \  
  --delete-after \  
  ${i} ${SMAGESCRIPTSDIR}  
   
  if [ "$?" == "0" ]  
  then  
  break  
  else  
  continue  
  fi  
   
  done  
   
  #clean up backup files (foo~)  
  find ${SMAGESCRIPTSDIR} -name *~ -exec rm '{}' ';'  
   
  xtitleclean  
 }  
106    
107  # dummy function, used if that not exist in smage file   smagesource ${SMAGENAME} || die "download source failed"
 src_prepare() {  
  echo "no src_prepare defined"  
  sleep 2  
  return 0  
 }  
108    
109  # dummy function, used if that not exist in smage file   # overridable sourcedir; must be declared after source of the smage2
110  src_compile() {   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
  echo "no src_compile defined"  
  sleep 2  
  return 0  
 }  
111    
112  # dummy function, used if that not exist in smage file   [ -z "${SRC_URI}" ] && die "Nothing declared to calculate."
 src_install() {  
  echo "no src_install defined"  
  sleep 2  
  return 0  
 }  
113    
114     # end of array
115     EOA=${#SRC_URI[*]}
116    
117  build_mage_script() {   [ ! -d ${MD5DIR} ] && install -d ${MD5DIR}
  return 0  
 }  
118    
119  mconfigure() {   # clear md5sum file
120   if [ -x ./configure ]   MY_MD5_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"
121   then   echo -n > ${MY_MD5_FILE}
  ./configure \  
  --prefix=/usr \  
  --host=${CHOST} \  
  --mandir=/usr/share/man \  
  --infodir=/usr/share/info \  
  --datadir=/usr/share \  
  --sysconfdir=/etc \  
  --localstatedir=/var/lib \  
  "$@" || die "mconfigure failed"  
  else  
  echo "configure is not an executable ..."  
  exit 1  
  fi  
 }  
122    
123  minstall() {   for ((i=0; i < EOA; i++))
124   if [ -f ./[mM]akefile -o -f ./GNUmakefile ] ; then   do
125   make prefix=${BINDIR}/usr \   # url to file
126   datadir=${BINDIR}/usr/share \   my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"
  infodir=${BINDIR}/usr/share/info \  
  localstatedir=${BINDIR}/var/lib \  
  mandir=${BINDIR}/usr/share/man \  
  sysconfdir=${BINDIR}/etc \  
  "$@" install || die "minstall failed"  
         else  
                 die "no Makefile found"  
         fi  
 }  
127    
128  mmake() {   # subdir in sources dir; the my_SRCI_URI file goes to there
129   make ${MAKEOPTS} ${EXTRA_EMAKE} "$@"   my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"
 }  
130    
131  munpack() {   # if my_src_uri_dest is not equal my_src_uri; than an other dir is used
132   local SRCFILE   if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]
  local IFTAR  
  local DEST  
   
  SRCFILE=$1  
   
  if [ -z "$2" ]  
  then  
  DEST=${BUILDDIR}  
  else  
  DEST=$2  
  fi  
   
  case "${SRCFILE##*.}" in  
  bz2)  
  IFTAR="$(basename $SRCFILE .bz2)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
133   then   then
134   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   MY_SRC_FILE="${my_SRC_URI_DEST}/$(basename ${SRC_URI[${i}]})"
135     else
136     MY_SRC_FILE="$(basename ${SRC_URI[${i}]})"
137   fi   fi
138   ;;  
139   gz)   if [ -e "${CALC_SOURCEDIR}/${MY_SRC_FILE}" ]
  IFTAR="$(basename $SRCFILE .gz)"  
  IFTAR="${IFTAR##*.}"  
  if [ "${IFTAR}" == "tar" ]  
140   then   then
141   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   echo "calculating $(basename ${MY_SRC_FILE}) ..."
142     ( cd ${CALC_SOURCEDIR}; md5sum "${MY_SRC_FILE}" ) >> ${MY_MD5_FILE}
143     else
144     echo "WARNING: File '$(basename ${MY_SRC_FILE}) not found in ${CALC_SOURCEDIR}."
145   fi   fi
146   ;;  
147   tbz2)   # unset them to be shure
148   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   unset my_SRC_URI
149   ;;   unset my_SRC_URI_DEST
150   tgz)   unset my_SRC_URI_MIRROR
151   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   unset my_SOURCEDIR
152   ;;   done
153   *)  
154   die "munpack failed"   echo
155   ;;   echo "Calculating of md5 sums for '$(basename ${SMAGENAME} .${SMAGESUFFIX})' done."
156   esac   echo
157  }   else
158     echo "Usage: Calculating MD5 Sums:"
159  mpatch() {   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
160   local PATCHOPTS   echo
161   local PATCHFILE   echo
162     echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
163   PATCHOPTS=$1   echo
164   PATCHFILE=$2   exit 1
165     fi
  patch "${PATCHOPTS}" -i ${SOURCEDIR}/${PNAME}/${PATCHFILE}  
 }  
   
166    
167  minstalldocs() {   exit 0
168   local docfiles  fi
   
  docfiles="$@"  
   
  if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]  
  then  
  install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."  
  fi  
   
  for i in ${docfiles}  
  do  
  cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."  
  install -m 0644 ${SRCDIR}/${i}.gz \  
  ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."  
  done  
 }  
169    
170  setup_distcc_environment(){  # download sources
171   if [ -x /usr/bin/distcc ]  if [ "$1" == "download" -a -n "$2" ]
172    then
173     if [ ! -d ${SMAGESCRIPTSDIR} ]
174   then   then
175   echo "Using DistCC for compilation ..."   install -d ${SMAGESCRIPTSDIR}
176   export PATH=/usr/lib/distcc/bin:${PATH} || die "distcc: could not export new $PATH"   fi
177    
178     # get smage
179     SMAGENAME="$2"
180     MD5DIR="$(dirname ${SMAGENAME})/md5"
181     smagesource ${SMAGENAME} || die "download source failed"
182    
183   #export distcc as compiler   download_sources
184  # export CC="distcc"   exit 0
185  # export CXX=distcc  fi
186    
187   export DISTCC_DIR="${DISTCC_DIR}" || die "distcc_dir export failed"  # regen-mage-tree
188    if [ "$1" == "only-regen-tree" -a -n "$2" ]
189    then
190     # set correct SMAGENAME
191     SMAGENAME="$2"
192     MD5DIR="$(dirname ${SMAGENAME})/md5"
193     smagesource ${SMAGENAME} || die "regen: smage2 not found"
194    
195     regen_mage_tree
196    
197   #ccache + distcc together   # build several subpackages
198   if [ "${SMAGE_USE_CCACHE}" == "true" ]   if [[ -n ${SPLIT_PACKAGES} ]]
199   then   then
200   if [ -x /usr/bin/ccache ]   split_save_variables
201     for subpackage in ${SPLIT_PACKAGES}
202     do
203     # get the right variables for the split
204     export PNAME="${subpackage}"
205     split_info_${subpackage}
206     # fix PCATEGORIE -> PCAT
207     if [[ ! -z ${PCATEGORIE} ]]
208   then   then
209   echo "Preparing DistCC to work together with CCache ..."   PCAT="${PCATEGORIE}"
210   #export CCACHE_PREFIX="distcc" || die "distcc: could not set ccach_prefix"   unset PCATEGORIE
 # export CC="ccache distcc"  
 # export CXX="ccache distcc"  
211   fi   fi
212   fi   # build md5sum for existing packages
213     generate_package_md5sum \
214   #creating distcc tempdir   --pcat "${PCAT}" \
215   install -o distcc -g daemon -d ${DISTCC_DIR}   --pname "${PNAME}" \
216   chmod 1777 ${DISTCC_DIR}   --pver "${PVER}" \
217   fi   --pbuild "${PBUILD}" \
218  }   --parch "${ARCH}"
219     # restore smage environment
220     split_restore_variables
221     done
222     # unset all saved smage variables
223     split_unset_variables
224    
225  setup_ccache_environment(){   else
226   if [ -x /usr/bin/ccache ]   # build md5sum for existing packages
227   then   generate_package_md5sum \
228   echo "Using CCache for compilation ..."   --pcat "${PCAT}" \
229   export PATH=/usr/lib/ccache/bin:${PATH} || die "ccache: could not export new $PATH"   --pname "${PNAME}" \
230   #unset CC CXX   --pver "${PVER}" \
231     --pbuild "${PBUILD}" \
232     --parch "${ARCH}"
233   fi   fi
 }  
234    
235  if [ -z "$1" ]   exit 0
 then  
  showversion  
  echo  
  echo "No .smage2 file given. Exiting."  
  echo  
  exit 1  
236  fi  fi
237    
238  #updating smage2-scripts  if [ "$1" == "--create-src-tarball" -a -n "$2" ]
 if [ "$1" == "update" ]  
239  then  then
240   showversion   # set correct SMAGENAME
241   if [ ! -d ${SMAGESCRIPTSDIR} ]   SMAGENAME="$2"
242     MD5DIR="$(dirname ${SMAGENAME})/md5"
243    
244     echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
245    
246     smagesource ${SMAGENAME} || die "regen: smage2 not found"
247    
248     if [[ -d ${SOURCEDIR}/${PNAME} ]]
249   then   then
250   install -d ${SMAGESCRIPTSDIR}   echo -e "${COLGREEN}Deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
251     rm -rf ${SOURCEDIR}/${PKGNAME}
252   fi   fi
253   syncsmage2  
254     download_sources
255     source_pkg_build ${SMAGENAME}
256   exit 0   exit 0
257  fi  fi
258    
259    if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
 if [ ! -e ${MLIBDIR}/pkgbuild_dir.sh ]  
260  then  then
261   die "Error: ${MLIBDIR}/pkgbuild_dir.sh not found. Aborting."   SRCPKGTARBALL="${2}"
262  fi   msetfeature "srcpkgtarball"
263    
264  if [ -z "`basename ${SMAGENAME}|grep .${SMAGESUFFIX}`" ]   # abort if given file is not a source pkg
265  then   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
  die "File '`basename ${SMAGENAME}`' is not a sMage v${SMAGEVERSION} file. Aborting."  
 fi  
266    
267  if [ -z "${SOURCEDIR}" ]   # set correct SMAGENAME; use the one that the src_pkg provide
268  then   # /path/to/SOURCEDIR/PNAME/SMAGENAME
269   die "\$SOURCEDIR not found. Please setup your mage.rc correctly."   SMAGENAME="${SOURCEDIR}/$(basename ${SRCPKGTARBALL%-*-*})/$(basename ${SRCPKGTARBALL} .${SRCPKGSUFFIX}).${SMAGESUFFIX}"
 fi  
270    
271  if [ -z "${SMAGESCRIPTSDIR}" ]   echo -e "${COLGREEN}Using src-tarball ${COLBLUE}${SRCPKGTARBALL}${COLGREEN} ...${COLDEFAULT}"
 then  
  die "\$SMAGESCRIPTSDIR not found. Please setup your mage.rc correctly."  
 fi  
272    
273  if [ -z "${SMAGE2RSYNC}" ]   [[ ! -d ${SOURCEDIR} ]] && install -d ${SOURCEDIR}
 then  
  echo "\$SMAGE2RSYNC not found. Please setup your mage.rc correctly."  
  exit 1  
 fi  
274    
275  if [ -z "${BINDIR}" ]   # unpack srctarball
276  then   [[ ! -f ${SRCPKGTARBALL} ]] && die "Error: ${SRCPKGTARBALL} does not exist. Aborting."
  die "no BINDIR variable found in /etc/mage.rc"  
 fi  
277    
278  if [ -z "${CHOST}" ]   tar xvjf ${SRCPKGTARBALL} -C ${SOURCEDIR} || die  "Error unpackung src-tarball ${SRCPKGTARBALL}"
 then  
  die "no CHOST variable found in /etc/mage.rc"  
 fi  
279    
280  if [ -z "${CFLAGS}" ]   [[ ! -f ${SMAGENAME} ]] && die "Included smage2 file in src-tarball not found: ${SMAGENAME}"
 then  
  die "no CFLAGS variable found in /etc/mage.rc"  
281  fi  fi
282    
283  if [ -z "${CXXFLAGS}" ]  if [ "$1" == "--resume" -a -n "$2" ]
284  then  then
285   die "no CXXFLAGS variable found in /etc/mage.rc"   msetfeature "resume"
286     SMAGENAME="$2"
287  fi  fi
288    
289    [ ! -e ${MLIBDIR}/pkgbuild_dir ] && die "Error: ${MLIBDIR}/pkgbuild_dir not found. Aborting."
290    [ -z "$(basename ${SMAGENAME} | grep .${SMAGESUFFIX})" ] &&
291     die "File '$(basename ${SMAGENAME})' is not a sMage v${SMAGEVERSION} file. Aborting."
292    [ -z "${SOURCEDIR}" ] && die "\$SOURCEDIR not found. Please setup your ${MAGERC} correctly."
293    [ -z "${SMAGESCRIPTSDIR}" ] && die "\$SMAGESCRIPTSDIR not found. Please setup your ${MAGERC} correctly."
294    [ -z "${SMAGE2RSYNC}" ] && die "\$SMAGE2RSYNC not found. Please setup your ${MAGERC} correctly."
295    [ -z "${BINDIR}" ] && die "no BINDIR variable found in ${MAGERC}"
296    [ -z "${CHOST}" ] && die "no CHOST variable found in ${MAGERC}"
297    [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
298    [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
299    
300  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
301  PKGNAME="${PNAME}-${PVER}-${CHOST%%-*}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}"
302    MD5DIR="$(dirname ${SMAGENAME})/md5"
303    SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"
304    
305  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
306  #fixes some issues with these functions  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
307    
308    if mqueryfeature "srcpkgbuild"
309    then
310     if [[ -d ${SOURCEDIR}/${PNAME} ]]
311     then
312     echo -e "${COLBLUE}===${COLGREEN} deleting old sourcefiles ${COLBLUE}${SOURCEDIR}/${PNAME}${COLGREEN} ...${COLDEFAULT}"
313     rm -rf ${SOURCEDIR}/${PNAME}
314     fi
315    fi
316    
317    # download sources
318    mqueryfeature "srcpkgtarball" || download_sources
319    
320    # fixes some issues with these functions
321  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
322  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
323    export -f src_check || die "src_check export failed"
324  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
325    
326  #fixes some compile issues  # fixes some compile issues
327  export CHOST="${CHOST}" || die "CHOST export failed"  export CHOST="${CHOST}" || die "CHOST export failed"
328  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"  export CFLAGS="${CFLAGS}" || die "CFLAGS export failed"
329  export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"  if [[ -z ${CXXFLAGS} ]]
330    then
331     export CXXFLAGS="${CFLAGS}" || die "CXXFLAGS export failed"
332    else
333     export CXXFLAGS="${CXXFLAGS}" || die "CXXFLAGS export failed"
334    fi
335    export LDFLAGS="${LDFLAGS}" || die "LDFLAGS export failed"
336  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
337  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
338    
339    # setup distcc
340    # setup for distcc goes *before* ccache, so ccache comes before distcc in path
341    mqueryfeature "distcc" && setup_distcc_environment
342    
343  #setup distcc  # setup icecc
344  #distcc mus be setup *before* ccache, as ccache need to be before distcc in path  # setup for icecc goes *before* ccache, so ccache comes before icecc in path
345  if [ "${SMAGE_USE_DISTCC}" == "true" ]  mqueryfeature "icecc" && setup_icecc_environment
346  then  
347   setup_distcc_environment  # setup ccache
348  fi  mqueryfeature "ccache" && setup_ccache_environment
349    
350  #setup ccache  if mqueryfeature "resume"
 if [ "${SMAGE_USE_CCACHE}" == "true" ]  
351  then  then
352   setup_ccache_environment   echo -e "${COLMAGENTA}Resume requested; continuing previous build${COLDEFAULT}"
 fi  
353    
354     # setup build logging
355     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
356     if [[ -f /var/log/smage/${PKGNAME}.log.bz2 ]]
357     then
358     bunzip2 -f /var/log/smage/${PKGNAME}.log.bz2
359     fi
360     echo -e "### Resume started on $(date) ###\n" >> /var/log/smage/${PKGNAME}.log
361    
362  # small sleep to show our settings  else
363  sleep 1   # clean up builddir if a previously one exist
364     if [ -d ${BUILDDIR} ]
365     then
366     rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
367     fi
368     install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
369    
370  #debug   # clean up srcdir if a previously unpacked one exist
371  #echo "CC=${CC}"   if [ -d ${SRCDIR} ]
372  #echo "CXX=${CXX}"   then
373  #echo "DISTCC_DIR=${DISTCC_DIR}"   rm -rf ${SRCDIR}
374  #echo "PATH: ${PATH}"   fi
 #echo "--------------------------------------"  
 #env  
 #echo "--------------------------------------"  
 #read  
 #debug end  
375    
376  #cleans up build if a previously one exists   # clean up bindir if a previous build exist or create a new one
377  if [ -d ${BUILDDIR} ]   if [ -d ${BINDIR} ]
378  then   then
379   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   rm -rf ${BINDIR}
380     fi
381     install -d ${BINDIR} || die "couldn't create \$BINDIR."
382    
383     # clean up package temp dir if a previous build exist
384     if [ -d ${BUILDDIR}/${PKGNAME} ]
385     then
386     rm -rf ${BUILDDIR}/${PKGNAME}
387     fi
388    
389     # clean up stamps dir
390     if [ -d ${BUILDDIR}/.stamps ]
391     then
392     rm -rf ${BUILDDIR}/.stamps
393     fi
394    
395     # setup build logging
396     [[ ! -d /var/log/smage ]] && install -d /var/log/smage
397     echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
398    fi
399    
400    if [[ ${PKGTYPE} = virtual ]]
401    then
402     echo "virtual package detected; nothing will be build ..."
403     # automatically set !pkgbuild here too
404     msetfeature "!pkgbuild"
405    else
406     ( run_resume src_prepare || src_prepare ) | ${SMAGE_LOG_CMD}
407     die_pipestatus 0 "src_prepare failed"
408     resume_stamp src_prepare
409     step_by_step src_prepare
410    
411     ( run_resume src_compile || src_compile ) | ${SMAGE_LOG_CMD}
412     die_pipestatus 0 "src_compile failed"
413     resume_stamp src_compile
414     step_by_step src_compile
415    
416     # only run checks if requested
417     if mqueryfeature "!check"
418     then
419     echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
420     else
421     ( run_resume src_check || src_check ) | ${SMAGE_LOG_CMD}
422     die_pipestatus 0 "src_check failed"
423     resume_stamp src_check
424     fi
425     step_by_step src_check
426    
427     # build several subpackages
428     if [[ -n ${SPLIT_PACKAGES} ]]
429     then
430     # save bindir & pname
431     split_save_variables
432     export SAVED_BINDIR="${BINDIR}"
433     for subpackage in ${SPLIT_PACKAGES}
434     do
435     split_info_${subpackage}
436     if [[ ${PKGTYPE} = virtual ]]
437     then
438     echo
439     echo -en "${COLBLUE}*** ${COLDEFAULT}"
440     echo -en "Virtual package detected"
441     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
442     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
443    
444     echo "virtual package detected; nothing will be build ..."
445     # automatically set !pkgbuild here too
446     msetfeature "!pkgbuild"
447     else
448     if typeset -f src_install_${subpackage} > /dev/null
449     then
450     # export subpackage bindir
451     export BINDIR="${SAVED_BINDIR}_${subpackage}"
452     # export PNAME, several internal function and include
453     # rely on this variable
454     export PNAME="${subpackage}"
455    
456     echo
457     echo -en "${COLBLUE}*** ${COLDEFAULT}"
458     echo -en "Running ${COLGREEN}split src_install()${COLDEFAULT}"
459     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
460     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
461    
462     ( run_resume src_install_${subpackage} || src_install_${subpackage} ) | ${SMAGE_LOG_CMD}
463     die_pipestatus 0 "src_install_${subpackage} failed"
464     resume_stamp src_install_${subpackage}
465     step_by_step src_install_${subpackage}
466     fi
467     fi
468     # restore smage environment
469     split_restore_variables
470     done
471     # unset all saved smage variables
472     split_unset_variables
473     else
474     ( run_resume src_install || src_install ) | ${SMAGE_LOG_CMD}
475     die_pipestatus 0 "src_install failed"
476     resume_stamp src_install
477     step_by_step src_install
478     fi
479  fi  fi
 install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  
480    
481  #cleans up srcdir if a previously unpacked one exists  # echo for sake of good-looking
482  if [ -d ${SRCDIR} ]  echo
483    
484    if mqueryfeature "!compressdoc"
485    then
486     echo -e "!compressdoc detected; documentation will not be compressed ..."
487    elif mqueryfeature "!pkgbuild"
488  then  then
489   rm -rf ${SRCDIR}   echo "!pkgbuild detected; skipping documentation compression..."
490    else
491     # compressing doc, info & man files
492     if [[ -n ${SPLIT_PACKAGES} ]]
493     then
494     # save smage environment
495     split_save_variables
496     for subpackage in ${SPLIT_PACKAGES}
497     do
498     # honor split_info
499     split_info_${subpackage}
500     if [[ ${PKGTYPE} = virtual ]]
501     then
502     # automatically set !pkgbuild here too
503     msetfeature "!pkgbuild"
504     fi
505    
506     if mqueryfeature "!compressdoc"
507     then
508     echo -e "!compressdoc detected; documentation of '${subpackage}' will not be compressed ..."
509     elif mqueryfeature "!pkgbuild"
510     then
511     echo "!pkgbuild detected; skipping documentation compression for '${subpackage}' ..."
512     else
513     run_resume post-mcompressdoc_${subpackage} || mcompressdocs ${BINDIR}_${subpackage}
514     resume_stamp post-mcompressdoc_${subpackage}
515     fi
516     # restore smage environment
517     split_restore_variables
518     done
519     # unset saved variables
520     split_unset_variables
521     else
522     run_resume post-mcompressdoc || mcompressdocs ${BINDIR}
523     resume_stamp post-mcompressdoc
524     fi
525  fi  fi
526    
527  #cleans up bindir if a previous build exists or creates a new one  if mqueryfeature "!libtool"
 if [ -d ${BINDIR} ]  
528  then  then
529   rm -rf ${BINDIR}   if mqueryfeature "!pkgbuild"
530     then
531     echo "!pkgbuild detected; skipping libtool archive stripping ..."
532     else
533     if [[ -n ${SPLIT_PACKAGES} ]]
534     then
535     # save smage environment
536     split_save_variables
537     for subpackage in ${SPLIT_PACKAGES}
538     do
539     # honor split_info
540     split_info_${subpackage}
541     if [[ ${PKGTYPE} = virtual ]]
542     then
543     # automatically set !pkgbuild here too
544     msetfeature "!pkgbuild"
545     fi
546    
547     if mqueryfeature "!libtool"
548     then
549     if mqueryfeature "!pkgbuild"
550     then
551     echo "!pkgbuild detected; skipping libtool archive stripping for '${subpackage}'..."
552     else
553     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
554     run_resume post-mstriplibtoolarchive_${subpackage} || mstriplibtoolarchive ${BINDIR}_${subpackage}
555     resume_stamp post-mstriplibtoolarchive_${subpackage}
556     fi
557     fi
558    
559     # restore smage environment
560     split_restore_variables
561     done
562     # unset saved variables
563     split_unset_variables
564     else
565     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
566     run_resume post-mstriplibtoolarchive || mstriplibtoolarchive ${BINDIR}
567     resume_stamp post-mstriplibtoolarchive
568     fi
569     fi
570  fi  fi
 install -d ${BINDIR} || die "couldn't create \$BINDIR."  
571    
572  #cleans up package temp dir if a previous build exists  if mqueryfeature "purge"
 if [ -d ${BUILDDIR}/${PKGNAME} ]  
573  then  then
574   rm -rf ${BUILDDIR}/${PKGNAME}   if mqueryfeature "!pkgbuild"
575     then
576     echo "!pkgbuild detected; skipping file purgation ..."
577     else
578     if [[ -n ${SPLIT_PACKAGES} ]]
579     then
580     # save smage environment
581     split_save_variables
582     for subpackage in ${SPLIT_PACKAGES}
583     do
584     # honor split_info
585     split_info_${subpackage}
586     if [[ ${PKGTYPE} = virtual ]]
587     then
588     # automatically set !pkgbuild here too
589     msetfeature "!pkgbuild"
590     fi
591    
592     if mqueryfeature "purge"
593     then
594     if mqueryfeature "!pkgbuild"
595     then
596     echo "!pkgbuild detected; skipping file purgation for '${subpackage}' ..."
597     else
598     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
599     run_resume post-mpurgetargets_${subpackage} || mpurgetargets ${BINDIR}_${subpackage}
600     resume_stamp post-mpurgetargets_${subpackage}
601     fi
602     fi
603    
604     # restore smage environment
605     split_restore_variables
606     done
607     # unset saved variables
608     split_unset_variables
609     else
610     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
611     run_resume post-mpurgetargets || mpurgetargets ${BINDIR}
612     resume_stamp post-mpurgetargets
613     fi
614     fi
615  fi  fi
616    
617  #cleans up timestamp if one exists  # stripping all bins and libs
618  if [ -f /var/tmp/timestamp ]  if mqueryfeature "!strip"
619  then  then
620   mage rmstamp   echo -e "!strip detected; package will not be stripped ..."
621  fi  elif mqueryfeature "!pkgbuild"
622    then
623     echo "!pkgbuild detected; skipping stripping of the package ..."
624    else
625     if [[ -n ${SPLIT_PACKAGES} ]]
626     then
627     # save smage environment
628     split_save_variables
629     for subpackage in ${SPLIT_PACKAGES}
630     do
631     # honor split_info
632     split_info_${subpackage}
633     if [[ ${PKGTYPE} = virtual ]]
634     then
635     # automatically set !pkgbuild here too
636     msetfeature "!pkgbuild"
637     fi
638    
639  src_prepare || die "src_prepare failed"   if mqueryfeature "!strip"
640  src_compile || die "src_compile failed"   then
641  src_install || die "src_install failed"   echo -e "!strip detected; package '${subpackage}' will not be stripped ..."
642     elif mqueryfeature "!pkgbuild"
643     then
644     echo "!pkgbuild detected; skipping stripping of the package '${subpackage}' ..."
645     else
646     echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
647     run_resume post-mstripbins_${subpackage} || mstripbins ${BINDIR}_${subpackage}
648     resume_stamp post-mstripbins_${subpackage}
649     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
650     run_resume post-mstriplibs_${subpackage} || mstriplibs ${BINDIR}_${subpackage}
651     resume_stamp post-mstriplibs_${subpackage}
652     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
653     run_resume post-mstripstatic_${subpackage} || mstripstatic ${BINDIR}_${subpackage}
654     resume_stamp post-mstripstatic_${subpackage}
655     fi
656    
657     # restore smage environment
658     split_restore_variables
659     done
660     # unset saved variables
661     split_unset_variables
662     else
663     echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
664     run_resume post-mstripbins || mstripbins ${BINDIR}
665     resume_stamp post-mstripbins
666     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
667     run_resume post-mstriplibs || mstriplibs ${BINDIR}
668     resume_stamp post-mstriplibs
669     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
670     run_resume post-mstripstatic || mstripstatic ${BINDIR}
671     resume_stamp post-mstripstatic
672     fi
673    fi
674    
675  #compressing doc, info & man files  if mqueryfeature "qalint"
 echo -e "Compressing man-pages ..."  
 if [ -d ${BUILDDIR}/builded/usr/share/man ]  
676  then  then
677   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man   if mqueryfeature "!pkgbuild"
678     then
679     echo "!pkgbuild detected; skipping QA lint checks ..."
680     else
681     if [[ -n ${SPLIT_PACKAGES} ]]
682     then
683     # save smage environment
684     split_save_variables
685     for subpackage in ${SPLIT_PACKAGES}
686     do
687     # honor split_info
688     split_info_${subpackage}
689     if [[ ${PKGTYPE} = virtual ]]
690     then
691     # automatically set !pkgbuild here too
692     msetfeature "!pkgbuild"
693     fi
694    
695     if mqueryfeature "qalint"
696     then
697     if mqueryfeature "!pkgbuild"
698     then
699     echo "!pkgbuild detected; skipping QA lint checks for '${subpackage}' ..."
700     else
701     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks for '${subpackage}' ...${COLDEFAULT}"
702     mqalint ${BINDIR}_${subpackage}
703     fi
704     fi
705    
706     # restore smage environment
707     split_restore_variables
708     done
709     # unset saved variables
710     split_unset_variables
711     else
712     echo -e "${COLBLUE}===${COLGREEN} running QA lint checks ...${COLDEFAULT}"
713     mqalint ${BINDIR}
714     fi
715     fi
716  fi  fi
717    
718  echo -e "Compressing info-pages ..."  if mqueryfeature "!pkgbuild"
 if [ -d ${BUILDDIR}/builded/usr/share/info ]  
719  then  then
720   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   echo -e "!pkgbuild detected; Package will not be build ..."
721    else
722     # build several subpackages
723     if [[ -n ${SPLIT_PACKAGES} ]]
724     then
725     split_save_variables
726     for subpackage in ${SPLIT_PACKAGES}
727     do
728     # get the right variables for the split
729     export PNAME="${subpackage}"
730     split_info_${PNAME}
731     # fix PCATEGORIE -> PCAT
732     if [[ ! -z ${PCATEGORIE} ]]
733     then
734     PCAT="${PCATEGORIE}"
735     unset PCATEGORIE
736     fi
737     if [[ ${PKGTYPE} = virtual ]]
738     then
739     # automatically set !pkgbuild here too
740     msetfeature "!pkgbuild"
741     fi
742    
743     # jump to next one if !pkgbuild is set in split_info
744     if mqueryfeature "!pkgbuild"
745     then
746     # restore smage environment
747     split_restore_variables
748     continue
749     fi
750    
751     # check if an special subpackage_pkgbuild exists
752     if typeset -f ${PNAME}_pkgbuild > /dev/null
753     then
754     # run it
755     run_resume post-${PNAME}_pkgbuild || ${PNAME}_pkgbuild
756     resume_stamp post-${PNAME}_pkgbuild
757     fi
758     # now create the target package
759     run_resume post-pkg_builddir_${PNAME} || ${MLIBDIR}/pkgbuild_dir \
760     "${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD}" \
761     "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
762     resume_stamp post-pkg_builddir_${PNAME}
763    
764     # build pkg-md5-sum if requested
765     run_resume post-md5sum_${PNAME} || generate_package_md5sum \
766     --pcat "${PCAT}" \
767     --pname "${PNAME}" \
768     --pver "${PVER}" \
769     --pbuild "${PBUILD}" \
770     --parch "${ARCH}"
771     resume_stamp post-md5sum_${PNAME}
772    
773     echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}$(print_distrotag)-${PBUILD} successfully builded.\n${COLDEFAULT}"
774    
775     # restore smage environment
776     split_restore_variables
777     done
778     # unset all saved smage variables
779     split_unset_variables
780    
781     else
782     run_resume post-pkg_builddir || ${MLIBDIR}/pkgbuild_dir ${PKGNAME} ${BINDIR} || die "package-build failed"
783     resume_stamp post-pkg_builddir
784    
785     # build pkg-md5-sum if requested
786     run_resume post-md5sum || generate_package_md5sum \
787     --pcat "${PCAT}" \
788     --pname "${PNAME}" \
789     --pver "${PVER}" \
790     --pbuild "${PBUILD}" \
791     --parch "${ARCH}"
792     resume_stamp post-md5sum
793    
794     echo -e "${COLGREEN}\nPackage ${PKGNAME} successfully builded.\n${COLDEFAULT}"
795     fi
796    
797     # build src-pkg-tarball if requested
798     if mqueryfeature "srcpkgbuild"
799     then
800     run_resume post-srcpkgbuild || source_pkg_build ${SMAGENAME}
801     resume_stamp post-srcpkgbuild
802     fi
803  fi  fi
804    
805  #the new buildpkg command  # auto regen mage tree if requested
806  case ${NOPKGBUILD} in  regen_mage_tree
807   true|TRUE|yes|y)  
808   echo -e "NOPGKBUILD=true detected; Package will not be build ..."  if mqueryfeature "buildlog"
809   ;;  then
810   *)   bzip2 -9f /var/log/smage/${PKGNAME}.log
811   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"  else
812   echo -e "\nPackage ${PKGNAME} successfully builded.\n"   [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
813   ;;  fi
 esac  
814    
 #for sure  
 unset NOPKGBUILD  
   
815  xtitleclean  xtitleclean
 #echo -e "\nPackage ${PKGNAME} successfully builded.\n"  

Legend:
Removed from v.57  
changed lines
  Added in v.2631